#include "taskFlyport.h"

void commande(char *cmde,TCP_SOCKET TCPSocket);
void Tcp_lire_temperature(TCP_SOCKET TCPSocket);
void Tcp_ecrire_out4(TCP_SOCKET TCPSocket,char etat);

#define myTCPWrite(TCPSocket, cmde) TCPWrite(TCPSocket, cmde,strlen(cmde))

void FlyportTask()
{
	BOOL clconn = FALSE;	
	char TCPPort[5]="2000";
	TCP_SOCKET TCPSocket = INVALID_SOCKET;			
	char TCPBuff[31];

	ADCInit ( );	
	IOInit (o4,out);  
	IOPut(o4,off);
	
	WFConnect(WF_DEFAULT);
	while (WFStatus != CONNECTED);
	
	UARTWrite(1,"WIfi Flyport connected... hello world!\r\n");	
	UARTWrite(1,"Creation socket Tcp : ");
	UARTWrite(1,TCPPort);
	UARTWrite(1,".\r\n");	
 
	TCPSocket = TCPServerOpen(TCPPort);
	UARTWrite(1,"Serveur Socket Tcp ouvert sur port ");
	UARTWrite(1,TCPPort);
	UARTWrite(1,".\r\n");	
	 
	while(1)
	{
		if(TCPisConn(TCPSocket)) // On fait si un client est connecté.
			{
			 if (clconn == FALSE) // On teste si le client vient de se connecter.
				{				  // si le client vient de se connecter, on lui envoie un message.
					clconn = TRUE;  // on mémorise que la connexion est prise en compte
		            IOPut(o4,on);			// affiche led IO4 connexion Tcp. 	
					myTCPWrite(TCPSocket, "Bonjour, bienvenue\r\n"); // renvoie hello au client
					UARTWrite(1,"Client connecte\r\n");	// pour test indique sur rs232.
				}		
				else // sinon on vérifie si le client envoie un ordre
				 {
				  if (TCPRxLen(TCPSocket) > 0) // y a t'il un message du client ?
			       {	 
				    TCPRead(TCPSocket, TCPBuff,TCPRxLen(TCPSocket));
				    UARTWrite(1, TCPBuff);  // copie message reçu vers RS232 pour info.
					UARTWrite(1,"\r\n");						
					commande(TCPBuff,TCPSocket);
			        }				 
				 }	 
			}
			else
			{
			  if (clconn == TRUE) // test fin de connexion client
				{
					IOPut(o4,off);
					UARTWrite(1,"CLIENT deconnecte\r\n");						
					clconn = FALSE;
				}			
			}
	}
}

void commande(char *cmde,TCP_SOCKET TCPSocket)
 {
    char *ptr_egal;	 
    ptr_egal = memchr(cmde, '=', strlen(cmde)); // cherche si caractère egal existe ?
	if (ptr_egal != NULL)  // si non nul on execute la commande
	{
		*ptr_egal = 0;  //TCPBuff contient la commande, ptr_egal+1 contient la commande.
		if (memcmp(cmde,"Temp=?",strlen(cmde))==0) Tcp_lire_temperature(TCPSocket);
		 else if(memcmp(cmde,"OUT4",strlen(cmde))==0) Tcp_ecrire_out4(TCPSocket,*(ptr_egal+1));
		  else 
			{
			myTCPWrite(TCPSocket, "Commande '");				
			myTCPWrite(TCPSocket, cmde);
			myTCPWrite(TCPSocket," --> ");	
			myTCPWrite(TCPSocket,(ptr_egal+1));		
			myTCPWrite(TCPSocket, "' inconnue");	
			TCPWrite(TCPSocket, "\r\n",2); 			
			}
	} else myTCPWrite(TCPSocket,"Commande inconnue\r\n");
 }
void Tcp_lire_temperature(TCP_SOCKET TCPSocket)
 {
	char AN0String[8];
	int ADval;	
	ADval =  ADCVal(1);
	ADval = ADval * 2 / 5 - 273;
	sprintf(AN0String,"%d\r\n",ADval);
	myTCPWrite(TCPSocket, AN0String);	
	UARTWrite(1,AN0String);
	
 }
void Tcp_ecrire_out4(TCP_SOCKET TCPSocket,char etat)
 {
	 if (etat ==  '1') 	IOPut(o4,on);
	  else 	IOPut(o4,off);
	 myTCPWrite(TCPSocket,"Ecrire OUT4");	

	 TCPWrite(TCPSocket, "\r\n",2); 
	 UARTWrite(1,"Ecrire OUT4\r\n");	 
 }


